# Go 学习之路：Go 开发者博客、Go 微信公众号、Go 学习资料（文档、书籍、视频）

[![Build Status](https://travis-ci.org/developer-learning/learning-golang.svg?branch=master)](https://travis-ci.org/developer-learning/learning-golang) [![Go Report Card](https://goreportcard.com/badge/github.com/developer-learning/learning-golang)](https://goreportcard.com/report/github.com/developer-learning/learning-golang)  [![Documentation](https://godoc.org/github.com/developer-learning/learning-golang?status.svg)](http://godoc.org/github.com/developer-learning/learning-golang) [![Coverage Status](https://coveralls.io/repos/github/developer-learning/learning-golang/badge.svg?branch=master)](https://coveralls.io/github/developer-learning/learning-golang?branch=master) [![GitHub issues](https://img.shields.io/github/issues/developer-learning/learning-golang.svg?label=Issue)](https://github.com/developer-learning/learning-golang/issues) [![license](https://img.shields.io/github/license/developer-learning/learning-golang.svg?maxAge=2592000)](https://github.com/developer-learning/learning-golang/LICENSE) [![Release](https://img.shields.io/github/release/developer-learning/learning-golang.svg?label=Release)](https://github.com/developer-learning/learning-golang/releases)

Go 学习之路将会不断更新维护，如果有推荐的博客、微信公众号、学习资料，可以提交 Issue。

=======
**注意：《Go 学习之路》已经迁移到[https://github.com/developer-learning/learning-golang](https://github.com/developer-learning/learning-golang)。**

## Stargazers over time

[![Stargazers over time](https://starcharts.herokuapp.com/developer-learning/learning-golang.svg)](https://starcharts.herokuapp.com/developer-learning/learning-golang)

[learning-golang Star History and Stats](https://seladb.github.io/StarTrack-js/?u=developer-learning&r=learning-golang)

----

## ➡️ [Go 夜读](https://reading.developerlearning.cn)

## Go 学习资料

| Go 入门|
|----|
| [Go 官方网站](https://golang.org/) 、[Go 中文官方网站](https://go-zh.org/) |
| [Go 入门指南](https://github.com/Unknwon/the-way-to-go_ZH_CN) |
| [Go 指南](https://tour.go-zh.org/) |
| [Go 怎么开始](https://github.com/alco/gostart) |
| [Go 开发向导 16 讲](https://github.com/hacking-code/golang-tutorials) |
| [Go 命令指南](https://github.com/hyper0x/go_command_tutorial) |
| [Go by Example](https://gobyexample.com/) [Go By Example 中文版](https://github.com/xg-wang/gobyexample) |
| [国外的一个高质量 Go 教程集](https://golangbot.com/learn-golang-series/) |
| [针对初学者的快速入门开发和使用 go](https://github.com/KeKe-Li/For-learning-Go-Tutorial) |
| [Go 快速入门资料](https://devhints.io/go) |
| [Go 标准库](https://medium.com/golangspec) |
| [Go 简易教程](https://github.com/songleo/the-little-go-book_ZH_CN) |
| [Go Programs](http://www.golangprograms.com/) |
| [Go(lang) examples - (explain the basics of golang)](https://github.com/SimonWaldherr/golang-examples) |
| [A set of example golang code to start learning Go](https://github.com/mkaz/working-with-go) |
| [快学 Go 语言](https://zhuanlan.zhihu.com/quickgo) |
| [从零到 Go 大神](https://medium.freecodecamp.org/learning-go-from-zero-to-hero-d2a3223b3d86) |

| Go 进阶|
|----|
| [Go 官方博客](https://blog.golang.org/) |
| [Go 官方包文档-pkg](https://golang.org/pkg/) |
| [Go 标准库中文文档-cngolib](http://cngolib.com/)| |
| [深入理解 Go by teh-cmc](https://github.com/teh-cmc/go-internals)|
| [深入理解 Go by tiancaiamao](https://github.com/tiancaiamao/go-internals) |
| [Go 内部原理的一系列文章和视频](https://github.com/emluque/golang-internals-resources)|
| [编写和优化 Go 代码](https://github.com/dgryski/go-perfbook/) |
| [Go 语言博客实践](https://github.com/achun/Go-Blog-In-Action) |

| Go 书籍|
|-----|
| [Go Web 编程](https://github.com/astaxie/build-web-application-with-golang) |
| [雨痕的《Go 学习笔记》，正在编写第六版，可于微博下载预览版，或关注公众号(2018-05-07)](https://github.com/qyuhen/book) |
| [Go 语言圣经](https://www.gitbook.com/book/wizardforcel/gopl-zh/details) / [Go 语言圣经](https://github.com/golang-china/gopl-zh) |
| [GO SCP](https://checkmarx.gitbooks.io/go-scp/content/) |
| [List of Golang books](https://github.com/dariubs/GoBooks) |
| [《Go语言高级编程》开源免费图书(开发中...) ](https://github.com/chai2010/advanced-go-programming-book) |
| [一本学习 Go 语言的免费电子书。 ](https://github.com/mikespook/Learning-Go-zh-cn) |
| [《Effective Go》中英双语版](https://github.com/bingohuang/effective-go-zh-en) |
| [Go 101](https://github.com/go101/go101) ([中文版](https://github.com/golang101/golang101)) |
| [Go Language CookBook With Examples](https://ednsquare.com/publisher/view/Go-Language-CookBook-With-Examples------xOhLZaZVGG) |
| [Go for Industrial Programming - Go 工业级编程](https://peter.bourgon.org/go-for-industrial-programming/) |
| [Learn Go with tests](https://github.com/quii/learn-go-with-tests) |
| [Go-SCP](https://github.com/Checkmarx/Go-SCP) |
| [An example of gin](https://github.com/EDDYCJY/go-gin-example) |
| [Go 语言原本（基于 Go 1.14）](https://changkun.de/golang) |
| [Go 语言设计与实现](https://draveness.me/golang) |

| Go 面试|
|----|
| [Go 开发建议](https://github.com/cristaloleg/go-advices)|
| [精华的 Go 面试题和答案](https://github.com/goquiz/goquiz.github.io)|
| [编程面试题的 Go 实现](https://github.com/mrekucci/epi)|
| [Exercism](http://exercism.io/languages/go/about) |
| [面前必看](https://github.com/qcrao/interview) |

| Go 其他|
|----|
| [Gopher 阅读清单](https://github.com/enocom/gopher-reading-list) |
| [Go 知识图谱](https://github.com/gocn/knowledge) |
| [Go 语言学习资源整理](https://zhuanlan.zhihu.com/p/25493806) |
| [Golang 标准包解析](https://github.com/syaning/go-pkgs) |
| [Golang 的标准库中文版，由 Go 友团翻译](https://github.com/jemygraw/GoStandardLibrary-Chinese) |
| [《Go语言标准库》](https://github.com/polaris1119/The-Golang-Standard-Library-by-Example) |
| [设计模式 Golang实现－《研磨设计模式》读书笔记](https://github.com/senghoo/golang-design-pattern) |
| [GopherChina2018: 深入CGO编程 - 最新修订](https://github.com/chai2010/gopherchina2018-cgo-talk) |
| [《啊哈!算法》-Go 实现](https://github.com/eruca/aha) |
| [大道至简—GO语言最佳实践](https://mp.weixin.qq.com/s/hE7ecSywWY8SxoQV0OwBQg) |
| [了解 Go 和 database 交互最佳实践教程](http://go-database-sql.org/overview.html) |
| [Go实战--golang新手入门常见错误(The way to go)](https://blog.csdn.net/wangshubo1989/article/details/72956065) |
| [Go 箴言(go-proverbs) - Rob Pike](https://go-proverbs.github.io/) |
| [Go 相关的教程](https://appliedgo.net/) |
| [KTH 的 Stefan Nilsson 教授自己写的算法和 Go 代码](https://yourbasic.org/) |
| [终极 Go 学习指南 Ultimate Go study guides](https://github.com/hoanhan101/ultimate-go) |
| [从问题切入，串连 Go 语言相关的所有知识，融会贯通。](https://github.com/qcrao/Go-Questions) |

## Go 学习视频

| 课程名称 | 简单介绍 |
|----|----|
| [Go 编程基础](https://github.com/Unknwon/go-fundamental-programming) | 这套视频适合初学者。 |
| [Go Web 基础](https://github.com/Unknwon/go-web-foundation) | 主要面向完成《Go 编程基础》教程后希望进一步了解有关 Go Web 开发的学习者。|
| [Go 名库讲解](https://github.com/Unknwon/go-rock-libraries-showcases) | 主要是对 Go 语言的第三方库进行评测讲解的，集博客、示例与语音视频为一体的综合教程，适合完成《Go 编程基础》教程之后的学习者。|
| [Go 语言第一课](http://www.imooc.com/learn/345)|郝林|
| [Go 箴言 - Rob Pike](https://www.youtube.com/watch?v=PAAkCSZUG1c) |
| [Learn Go Syntax in one video](https://www.youtube.com/watch?v=CF9S4QZuV30) | 一小时教你 Go 语法的视频 |
| [Todd McLead](https://www.youtube.com/channel/UCElzlyMtkoXaO3kFa5HL0Xw) | 非常热爱分享 Go 教程的大叔，有开通 Udemy 课程。|
| [Go In 5 Minutes](https://www.youtube.com/channel/UC2GHqYE3fVJMncbrRd8AqcA) | 5分钟学一个小知识点。 |
| [JustForFunc](https://www.youtube.com/channel/UC_BzFbxG2za3bp5NRRRXJSw) | 很多知识点的 Gopher，YouTuber 教学视频 |
| [Jon Calhoun](https://www.youtube.com/user/joncalhoun/playlists) | 一系列的 Go 实现的算法视频。 |
| [Go 语言基础教程 (O’Reilly)](http://www.bilibili.com/video/av8845689/) | O‘Reilly 的 Go 语言基础教程。|
| [Go Web Programming Bootcamp](http://www.golang-book.com/guides/bootcamp) | Todd McLeod 在别的学校开过的训练营视频，从 Go 基础讲到基础的服务器开发和 GAE。 |
| [Go 夜读](https://www.youtube.com/c/Go%E5%A4%9C%E8%AF%BB) |


## Go 文章

| 标题 | 简单介绍 |
|----|----|
| [Create A Real Time Chat App With Golang, Angular 2, And Websockets](https://www.thepolyglotdeveloper.com/2016/12/create-real-time-chat-app-golang-angular-2-websockets/) | 对于用 Go 语言来入门后端的我来说，如何和其它技术结合使用令我耳目一新（尽管看起来不难）|
| [How do I go about learning Go?](https://medium.com/@IndianGuru/how-do-i-go-about-learning-go-3a58a3a29a0b) | |
| [Resources for new Go programmers](https://dave.cheney.net/resources-for-new-go-programmers) | |
| [Using Golang in Production - My Experiences](http://blog.tamizhvendan.in/blog/2017/05/01/using-golang-in-production-my-experiences/) | |

## Go 播客

| 名称 | 简单介绍 |
|----|----|
| [GoTime](https://changelog.com/gotime) | A panel of Golang experts and special guests discuss the Go programming language, the community, and everything in between. |

----

## Go 开发工具

### 1. Vim

[MacVim](https://github.com/macvim-dev/macvim) + [vim-go](https://github.com/fatih/vim-go)

[Golang 开发环境搭建-Vim 篇 by Tonybai](https://tonybai.com/2014/11/07/golang-development-environment-for-vim/)

### 2. 文本编辑器 + 插件

[Visual Studio Code](https://code.visualstudio.com)、[Sublime Text 3](https://www.sublimetext.com/3)、[Atom](https://atom.io)

VSCode 插件列表（欢迎大家补充）：

|插件名称|插件描述|
|----|----|
|GitLens|非常方便的查看文件代码的 commit 信息（提交时间，提交人等）。|
|Code Runner|针对非常多的语言而快速方便执行的小插件。|
|filesize|在 VSCode 底部工具栏，非常方便的显示文件大小。|
|Go|Go 语言插件。|
|Terminal|命令行工具插件。|
|Vim|Vim 插件|
|VSCode Great Icons|VSCode 美化不同的文件。|
|WakaTime|统计项目代码的时间。|
|BetterComments|代码注释|

### 3. IDE

IntelliJ idea + Go Plugin、[Goland](https://www.jetbrains.com/go/)、[LiteIDE](https://github.com/visualfc/liteide)

----

## 博客地址和 RSS 地址

本博客列表涉及的文章内容支持 [定制化 Google 搜索](https://cse.google.com/cse/publicurl?cx=012619441804928271226:u6z4yvp8enm)。

本博客列表也提供同步更新的 OPML 文件（[下载 OPML 文件](https://github.com/developer-learning/learning-golang/raw/master/blogcn.opml)），可供导入到例如 feedly 等第三方订阅工具中，特别感谢 [icepy](https://github.com/icepy) 提供自动转换脚本。这里有 [导入教程](http://blog.feedly.com/feedlimport/)，我对程序做了一点修改，rss 地址可选填。

本项目起源于 [iOSBlogCN](https://github.com/tangqiaoboy/iOSBlogCN)，非常感谢 [唐巧](https://github.com/tangqiaoboy/)。

注意：本项目中的 Export.py 文件必须用 python3 执行。

| 博客地址 (排名不分先后) | RSS 地址 |
| ----- | ----- |
| [The Go Programming Language Blog](https://blog.golang.org/)| 
| [Tony Bai -- 一个程序员的心路历程](http://tonybai.com/) | <http://tonybai.com/feed/>
| [Arthur 的博客](http://www.zenlife.tk/index) | <http://www.zenlife.tk/feed.atom>
| [鸟窝](http://colobu.com/) | <http://colobu.com/atom.xml>
| [飞雪无情的博客](http://www.flysnow.org) | <http://www.flysnow.org/index.xml>
| [午夜咖啡](http://jolestar.com/) | <http://jolestar.com/feed.xml>
| [蝈蝈俊的技术心得](http://www.cnblogs.com/ghj1976/) | <http://www.cnblogs.com/ghj1976/rss>
| [FuXiaohei.Me -- 傅小黑的自留地](http://fuxiaohei.me/) | 
| [无闻的小站](https://github.com/Unknwon/wuwen.org) | 
| [astaxie](https://my.oschina.net/astaxie) | <https://my.oschina.net/astaxie/rss>
| [熊窝窝 -- PHP、Codeigniter、JAVA、C#、JAVASCRIPT、LINUX、LATEX、GOLANG 等技术分享](http://www.baiyuxiong.com/) | <http://www.baiyuxiong.com/?feed=rss2>
| [风笑痴](http://lunny.info/) | 
| [getwe's Blog](http://getwe.cn/) | <http://getwe.cn/atom.xml>
| [Harold's Blog -- 个人技术笔记](http://oikomi.github.io/) | 
| [YanyiWu](http://yanyiwu.com/) | <http://yanyiwu.com/rss.xml>
| [努力加贝](http://www.nljb.net/) | 
| [ipfans's Blog](https://www.4async.com/) | <https://www.4async.com/atom.xml>
| [Cyeam -- 你不要用战术的勤奋掩盖战略的懒惰。](http://blog.cyeam.com/) | <http://blog.cyeam.com/atom.xml>
| [战魂小筑](http://www.cppblog.com/sunicdavy) | <http://www.cppblog.com/sunicdavy/rss.aspx>
| [My Candy](http://mengqi.info/) | <http://mengqi.info/feed.xml>
| [fatedier blog](http://blog.fatedier.com) | 
| [siddontang 的专栏-my thought for program。](http://blog.csdn.net/siddontang) | <http://blog.csdn.net/siddontang/rss/list>
| [holys'](http://holys.im) | 
| [domac 博客 life should be func](http://lihaoquan.me) |
| [Siddon's Blog-My thought for program](http://siddonWorldtang.com) | <http://siddontang.com/atom.xml>
| [Gopher beyond EI[i]phants](https://mikespook.com/) | <https://mikespook.com/feed/>
| [Golang 编程百例](https://www.zybuluo.com/Gestapo/note/32082) | 
| [七牛云 - 七牛团队博客](http://blog.qiniu.com/) | <http://blog.qiniu.com/feed>
| [博客 - PingCAP](https://pingcap.com/bloglist) | 
| [猎豹移动技术博客](http://dev.cmcm.com/) | <http://dev.cmcm.com/feed>
| [Huang Huang 的博客](https://mozillazg.github.io/) | <https://mozillazg.github.io/feeds/all.atom.xml>
| [Fiisio -- thinking and codeing](http://fiisio.me) | 
| [LittleFeng 的博客 -- Python、Golang、Java、后端技术](https://allenwind.github.io)
| [Legendtkl](http://legendtkl.com/) | 
| [行思錄,Travel Coder - Arch, Coding, Life Learning](https://liudanking.com) | 
| [jasper的技术小窝 - 关注DevOps、运维监控、Python、Golang、开源、大数据、web开发、互联网](http://www.opscoder.info) | 
| [Morsing's Blog](http://morsmachine.dk/) | <http://morsmachine.dk/feed.atom>
| [hanjm backend blog](https://imhanjm.com/) |
| [《Go 语言实战》作者之一的博客](https://www.goinggo.net/) |
| [Hi, I'm Francesc.](https://campoy.cat/blog) |
| [Michał Łowicki - Web Services @ Opera. Interested in Linux, Docker, NoSQL, Python, Golang and monitoring everything which moves. Never Satisfied.](https://medium.com/@mlowicki) |
| [三月沙](https://sanyuesha.com/) |
| [大桥下的蜗牛](https://blog.lab99.org/) |
| [煎鱼的迷之博客](https://github.com/EDDYCJY/blog) |
| [Stefno - 博客园](https://www.cnblogs.com/qcrao-2018/) |
| [No Headback - If you don't keep moving, you'll quickly fall behind.](http://xargin.com/readings/) |
| [面向信仰编程 Draveness's Blog](https://draveness.me/) | <https://draveness.me/feed.xml>
| [程序印象 知行合一 业精于勤](https://www.cn18k.com/) | <https://www.cn18k.com/atom.xml>

----
## Go 社区

| Go 语言社区（排名不分先后）|特色|
|----|----|
| [Go 中国技术社区](https://gocn.io)|GoCN 每日新闻、问答社区|
| [GO 语言中文网](http://studygolang.com)|问答社区、开源项目、资源、图书、下载、官方文档。|
| [Golang 中国](http://www.golangtc.com)|问答社区、图书、下载。|
| [Golang 语言社区 (www.Golang.LTD)](http://www.golang.ltd)|问答社区|

## 微信公众号

| 微信公众号 (排名不分先后) | 公众号 ID | 二维码|
| ----- | ----- | ----- |
| Go 中国|golangchina|![Go 中国](https://mp.weixin.qq.com/mp/qrcode?scene=10000004&size=102&__biz=MjM5OTcxMzE0MQ==&mid=2653369919&idx=1&sn=7cf1deca13da16a8cd4ba4ecd8ceba8c&send_time=) |
| Go 语言中文网|studygolang|
| 每日 go 语言|golang_everyday|![每日 go 语言](https://mp.weixin.qq.com/mp/qrcode?scene=10000004&size=102&__biz=MzA4MzI2NTU4NA==&mid=2465194512&idx=1&sn=d4dea33e9d93988fe4fbba39d849e9b0&send_time=) |
| Go 语言北京用户组|golang-beijing|![Go 语言北京用户组](https://mp.weixin.qq.com/mp/qrcode?scene=10000004&size=102&__biz=MzIzMjA5OTc3OQ==&mid=2652941809&idx=1&sn=734374b9030d0a9a9bbc08d5a13e8a13&send_time=) |
| Golang 语言社区|Golangweb|![Golang 语言社区](https://mp.weixin.qq.com/mp/qrcode?scene=10000004&size=102&__biz=MzAxMzc4Mzk1Mw==&mid=2649836890&idx=1&sn=97505941de4f6c51e31f3aea2d806e3a&send_time=) |
| PingCAP|pingcap2015|![PingCAP](https://mp.weixin.qq.com/mp/qrcode?scene=10000004&size=102&__biz=MzI3NDIxNTQyOQ==&mid=2247484607&idx=1&sn=d2e8374e7ee5ea91387d8d3d8ea69c96&send_time=) |
| 午夜咖啡|jolestar-blog|![午夜咖啡](https://mp.weixin.qq.com/mp/qrcode?scene=10000004&size=102&__biz=MzA4NjgwMDQ0OA==&mid=2652445522&idx=1&sn=36e34036016d3c9fae76173cb9e2c7a7&send_time=) |
| 飞雪无情|flysnow_org|![飞雪无情](https://mp.weixin.qq.com/mp/qrcode?scene=10000004&size=102&__biz=MzI3MjU4Njk3Ng==&mid=2247483751&idx=1&sn=15bf5e8ca24c565819bc07682502266f&send_time=) |
